<template>
  <a-layout id="components-layout-demo-custom-trigger">
    <a-layout-sider :trigger="null" collapsible>
      <div class="logo">
        <img src="../assets/logo.png" alt="">
      </div>
      <a-menu theme="dark" mode="inline" :default-selected-keys="['1']">
        <a-menu-item key="1">
          <a-icon type="user" />
          <span>用户管理</span>
        </a-menu-item>
      </a-menu>
    </a-layout-sider>
    <a-layout>
      <a-layout-content
        :style="{ padding: '24px', background: '#fff', minHeight: '280px' }"
      >
        <a-table :columns="columns" :data-source="columnsData" :loading="loading">
          <template slot="status" slot-scope="text, record">
           <a-tag :color="record.black == 0 ? '#517E55' : '#ccc'">{{record.black == 0 ? '已激活' : '已禁用'}}</a-tag>
          </template>
          <template slot="operation" slot-scope="text, record, index">
            <span v-if="record.user_name == 'admin'">-</span>
            <a class="action" v-else @click="handleClick(record, index)" :class="{'disabled': record.black == 0}">{{record.black == 0 ? '禁用' : '激活'}}</a>
          </template>
        </a-table>
      </a-layout-content>
    </a-layout>
    
  </a-layout>
  
</template>
<script>
export default {
  data() {
    return {
      columns: [
        {
          title: '用户ID',
          dataIndex: 'user_id',
          key: 'user_id'
        },{
          title: '用户名',
          dataIndex: 'user_name',
          key: 'user_name'
        },{
          title: '手机号',
          dataIndex: 'phone',
          key: 'phone'
        },{
          title: '邮箱',
          dataIndex: 'mail',
          key: 'mail'
        },{
          title: '状态',
          dataIndex: 'status',
          scopedSlots: { customRender: 'status' },
        },{
          title: '操作',
          dataIndex: 'operation',
          scopedSlots: { customRender: 'operation' },
        },
      ],
      columnsData: [],
      loading: false
    };
  },

  created() {
    this.getList()
  },

  methods: {
    async getList() {
      this.loading = true
      await this.$axios.get('user/query').then(res => {
        if (res.code == undefined) {
          this.columnsData = res
        }
      }).catch(() => {})
      this.loading = false
    },

    handleClick(record, index) {
      let url = ''
      if (record.black == 0) {
        url = 'user/disable'
      } else {
        url = 'user/open'
      }
      this.$axios.post(url, {
        user_id: record.user_id
      }).then(res => {
        if (res.code == 0) {
          if (record.black == 0) {
            this.$notification.success({
              message: '用户禁用成功'
            })
            this.columnsData[index].black = 1
          } else {
            this.$notification.success({
              message: '用户激活成功'
            })
            this.columnsData[index].black = 0
          }
        } else {
          if (record.black == 0) {
            this.$notification.error({
              message: '用户禁用失败'
            })
          } else {
            this.$notification.error({
              message: '用户激活失败'
            })
          }
        }
      }).catch(() => {
        if (record.black == 0) {
          this.$notification.error({
            message: '用户禁用失败'
          })
        } else {
          this.$notification.error({
            message: '用户激活失败'
          })
        }
      })
    }
  }
};
</script>
<style lang="less" scoped>
 /deep/ .ant-layout-sider-children {
   .logo {
     height: 66px;
     display: flex;
     align-items: center;
     justify-content: center;
     img {
       width: 150px;
     }
   }
 }
 /deep/ .ant-layout {
   .action {
     &.disabled {
       color: #ff3434;
     }
   }
 }
#components-layout-demo-custom-trigger .trigger {
  font-size: 18px;
  line-height: 64px;
  padding: 0 24px;
  cursor: pointer;
  transition: color 0.3s;
}

#components-layout-demo-custom-trigger .trigger:hover {
  color: #1890ff;
}
</style>